package com.mypro.manager;

import java.io.FileInputStream;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

/**
 * Xml
 * @author Leslie Leung
 *
 */
public class XmlManager {
	/**
	 * ȡXML
	 * @param fileName	Ҫxmlļ·ļ׺׺ͳһplist,бҪ޸ģ
	 * @param encode	ַ
	 * @return
	 */
	public static XmlPullParser getXmlParser(String fileName,String encode){
		try{
			// ô xml ļ XmlResourceParser 
//			XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
			XmlPullParserFactory factory = XmlPullParserFactory.newInstance(
					 
                    System.getProperty(XmlPullParserFactory.PROPERTY_NAME), 

           Thread.currentThread().getContextClassLoader().getClass() );

			factory.setNamespaceAware(true);
			XmlPullParser xml = factory.newPullParser();
			xml.setInput(new FileInputStream(fileName + ".plist"), encode);
			return xml;
		}catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * ȡǰǩֵ
	 * 
	 * @return
	 */
	public static String getValueByCurrentTag(XmlPullParser xml) {
		try {
			int eventType = xml.next();
			while (true) {
				// ȡǩ״̬
				if (eventType == XmlPullParser.TEXT) {
					return xml.getText().trim();
				}
				// ĵ״̬
				else if (eventType == XmlPullParser.END_DOCUMENT) {
					// ĵ˳ while ѭ
					break;
				}
				eventType = xml.next();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	/**
	 * ȡָƵıǩ
	 * 
	 * @return	true:ǩ  falseûǩ
	 */
	public static boolean gotoTagByTagName(XmlPullParser xml, String tagName) {
		try {
			int eventType = xml.next();
			String key = null;
			while (true) {
				// ǩʼ״̬
				if (eventType == XmlPullParser.START_TAG) {
					key = xml.getName();
					if (key.trim().equals(tagName)) {
						return true;
					}
				}
				// ĵ״̬
				else if (eventType == XmlPullParser.END_DOCUMENT) {
					// ĵ˳ while ѭ
					return false;
				}
				// лһ״̬õǰ״̬
				eventType = xml.next();

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}
}
