package mines;

import java.awt.*;

/**
 * 
 * @author Leslie Leung
 */
public class Field {
	public static final int STYLE_COVERED = 1;	//Fieldʱʽ
	public static final int STYLE_OPENED = 2;	//Fieldʱʽ
	public static final int STYLE_MARKED = 3;	//Fieldʱʽ
	public static final int FIELD_SIZE = 25;	//һӵĴС

	private int mineValue;	//Fieldĸֵ
	private int x;	//Fieldĺ
	private int y;	//Field
	private int style;	//Fieldʽ

	/**
	 * Field๹췽
	 * @param x 
	 * @param y 
	 */
	public Field(int x, int y) {
		this.x = x;
		this.y = y;
		style = STYLE_COVERED;	//ʼʽΪ
		mineValue = 0;	//ʼFieldΪףmineValueֵΪ0ʾ
	}

	/**
	 * ȡFieldĺ
	 * @return 
	 */
	public int getX() {
		return x;
	}

	/**
	 * ȡField
	 * @return 
	 */
	public int getY() {
		return y;
	}

	/**
	 * ĳFieldʽ
	 * @param style ʽ
	 */
	public void setStyle(int style) {
		this.style = style;
	}

	/**
	 * ͨmineValueֵΪ-100ʾFieldΪ
	 */
	public void setMine() {
		mineValue = -100;
	}

	/**
	 * ظFieldmineValue
	 * @return mineValue
	 */
	public int getMineValue() {
		return mineValue;
	}

	/**
	 * øFieldĵֵ
	 * @param value ֵ
	 */
	public void setMineValue(int value) {
		mineValue = value;
	}

	/**
	 * жϸFieldǷ
	 * @return trueǣfalse
	 */
	public boolean isMine() {
		return mineValue == -100;
	}

	/**
	 * жϸFieldǷ񱻱
	 * @return trueǣfalseû
	 */
	public boolean isMarked() {
		return style == STYLE_MARKED;
	}

	/**
	 * жϸFieldǷ񸲸
	 * @return trueǣfalseû
	 */
	public boolean isCovered() {
		return style == STYLE_COVERED;
	}

	/**
	 * жϸFieldǷѴ
	 * @return trueѴ򿪣falseû
	 */
	public boolean isOpened() {
		return style == STYLE_OPENED;
	}

	/**
	 * ͼ
	 * @param g Graphics g
	 */
	public void paintField(Graphics g) {
		int yCoordinate = x * FIELD_SIZE + 1;
		int xCoordinate = y * FIELD_SIZE + 1;
		
		if(isCovered()) {//ʽΪʱĻͼ
			g.setColor(Color.CYAN);
			g.fillRect(xCoordinate, yCoordinate, FIELD_SIZE - 2, FIELD_SIZE - 2);
		}
		
		if(isOpened()) {//ʽΪʱĻͼ
			if(mineValue > 0) {//Fieldĸֵ0ʱ
				g.setColor(Color.WHITE);
				g.fillRect(xCoordinate, yCoordinate, FIELD_SIZE - 2, FIELD_SIZE - 2);
				g.setColor(Color.BLACK);
				g.drawString(mineValue + "", y * FIELD_SIZE + FIELD_SIZE / 2, x * FIELD_SIZE + FIELD_SIZE / 2);
				
			} else if(mineValue == -100) {//Fieldǵʱ
				g.setColor(Color.RED);
				g.fillRect(xCoordinate, yCoordinate, FIELD_SIZE - 2, FIELD_SIZE - 2);
				
			} else if(mineValue == 0) {//FieldĸֵΪ0
				g.setColor(Color.WHITE);
				g.fillRect(xCoordinate, yCoordinate, FIELD_SIZE - 2, FIELD_SIZE - 2);
				
			}
		}

		if(isMarked()) {//ʽΪʱĻͼ
			g.setColor(Color.CYAN);
			g.fillRect(xCoordinate, yCoordinate, FIELD_SIZE - 2, FIELD_SIZE - 2);
			g.setColor(Color.MAGENTA);
			g.drawString("", y * FIELD_SIZE + FIELD_SIZE / 2, x * FIELD_SIZE + FIELD_SIZE / 2);
		}
	}
}
