package tetris;

/**
 * ĸ񷽿
 * @author Leslie Leung
 */
public class Tetromino {
	protected Cell[] cells;		//öcells洢ĸ񷽿
	protected Cell axis;	//ת
	protected Cell[] rotateCells;	//ҪתĸӼ
	
	/**
	 * ʵĸ񷽿ʱת㷨
	 * @param axis תᣬcells±Ϊ0CellΪת
	 * @param rotateCells Ҫתĸӵļ
	 */
	protected void anticlockwiseRotate(Cell axis, Cell[] rotateCells) {
		int oldX;	//ԱʾrotateCellĺ
		int oldY;	//ԱʾrotateCell
		int newX;	//ԱʾrotateCellתĺ
		int newY;	//ԱʾrotateCellת
		
		for(int i = 0; i < 3; i ++) {
			oldX = rotateCells[i].getX();
			oldY = rotateCells[i].getY();
			
			newX = axis.getX() - axis.getY() + oldY;	//º㷨
			newY = axis.getY() + axis.getX() - oldX;	//㷨
			
			rotateCells[i].setX(newX);		//Ŀӵĺ
			rotateCells[i].setY(newY);		//Ŀӵ
		}
	}
	
	/**
	 * ʵĸ񷽿˳ʱת㷨
	 * @param axis תᣬcells±Ϊ0CellΪת
	 * @param rotateCells Ҫתĸӵļ
	 */
	protected void clockwiseRotate(Cell axis, Cell[] rotateCells) {
		int oldX;	//ԱʾrotateCellĺ
		int oldY;	//ԱʾrotateCell
		int newX;	//ԱʾrotateCellתĺ
		int newY;	//ԱʾrotateCellת
		
		for(int i = 0; i < 3; i ++) {
			oldX = rotateCells[i].getX();
			oldY = rotateCells[i].getY();
			
			newX = axis.getX() - oldY + axis.getY();	//º㷨
			newY = axis.getY() + oldX - axis.getX();	//㷨
			
			rotateCells[i].setX(newX);		//Ŀӵĺ
			rotateCells[i].setY(newY);		//Ŀӵ
		}
	}
	
	/**
	 * ʵĸ񷽿Զ
	 */
	protected void softDrop() {
		int oldY;	//ĳǰ
		int newY;	//ĳ
		
		/* и */
		for(int i = 0; i < cells.length; i ++) {
			oldY = cells[i].getY();
			newY = oldY + 1;
			
			cells[i].setY(newY);
		}
	}
	
	/**
	 * ʵĸ񷽿Ƶ㷨
	 */
	protected void moveLeft() {
		int oldX;	//ĳǰĺ
		int newX;	//ĳƺĺ
		
		/* и */
		for(int i = 0; i < cells.length; i ++) {
			oldX = cells[i].getX();
			newX = oldX - 1;
			
			cells[i].setX(newX);
		}
	}
	
	/**
	 * ʵĸ񷽿Ƶ㷨
	 */
	protected void moveRight() {
		int oldX;	//ĳǰĺ
		int newX;	//ĳƺĺ
		
		/* и */
		for(int i = 0; i < cells.length; i ++) {
			oldX = cells[i].getX();
			newX = oldX + 1;
			
			cells[i].setX(newX);
		}
	}
	
	/**
	 * ĸ񷽿ĸӵļ
	 * @return Cellļ
	 */
	protected Cell[] getCells() {
		return cells;
	}
	
	/**
	 * ȡת
	 * @return ת
	 */
	protected Cell getAxis() {
		return axis;
	}
	
	/**
	 * ȡҪתĿӵļ
	 * @return Ŀӵļ
	 */
	protected Cell[] getRotateCells() {
		return rotateCells;
	}
	
	/**
	 * cells[0]Ϊת
	 */
	protected void setAxis() {
		axis = cells[0];
	}
	
	/**
	 * ½Ϊ3鲢cells[1]cells[2]cells[3]ӵrotateCells
	 */
	protected void setRotateCells() {
		rotateCells = new Cell[]{cells[1], cells[2], cells[3]};
	}
}
