package traingame;

import java.awt.Color;
import java.awt.Graphics;

/**
 * ֽ
 * @author Leslie Leung
 */
public class Card {
	public static final int SUIT_SPADE = 0;		//ʾ
	public static final int SUIT_HEART = 1;		//ʾ
	public static final int SUIT_DIAMOND = 2;	//ʾ
	public static final int SUIT_CLUB = 3;		//ʾ÷

	/* ʾ13ֵ   */
	public static final int POINT_A = 1;
	public static final int POINT_2 = 2;
	public static final int POINT_3 = 3;
	public static final int POINT_4 = 4;
	public static final int POINT_5 = 5;
	public static final int POINT_6 = 6;
	public static final int POINT_7 = 7;
	public static final int POINT_8 = 8;
	public static final int POINT_9 = 9;
	public static final int POINT_10 = 10;
	public static final int POINT_J = 11;
	public static final int POINT_Q = 12;
	public static final int POINT_K = 13;

	public static final int CARD_WIDTH = 71;		//ֽƵĿ
	public static final int CARD_HEIGHT = 96;		//ֽƵĸ߶

	private int suit;	//ʾֽƵĻʽ
	private int point;	//ʾֽƵĵ
	private boolean selected;	//ʾֽǷѡ
	private boolean face;	//ʾֽǱ泯ϻ泯
	private int x;		//
	private int y;		//

	/**
	 * 췽
	 * @param point ֽƵĵ
	 * @param suit ֽƵĻʽ
	 */
	public Card(int point, int suit) {
		this.point = point;	//ֽƵĵ
		this.suit = suit;	//ֽƵĻʽ
		selected = false;	//Ĭֽûѡ
		face = false;		//ĬֽƱ泯
	}

	/**
	 * ȡֽƵĺ
	 * @return 
	 */
	public int getX() {
		return x;
	}

	/**
	 * ȡֽƵ
	 * @return 
	 */
	public int getY() {
		return y;
	}

	/**
	 * ֽƵĺ
	 * @param x 
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * ֽƵ
	 * @param y 
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * ȡĳֽƵĵ
	 * @return ֽƵĵ
	 */
	public int getPoint() {
		return point;
	}

	/**
	 * ֽǷ泯
	 * @param isOpen Ƿ泯
	 */
	public void setFace(boolean isOpen) {//isOpenΪtrue泯ϣfalse泯
		face = isOpen;	
	}

	/**
	 * ֽǷѡ
	 * @param isSelected Ƿѡ
	 */
	public void setSelected(boolean isSelected) {//isSelectedΪtrueѡУfalseûѡ
		selected = isSelected;
	}

	/**
	 * жֽǷѡ
	 * @return trueѡУfalseûѡ
	 */
	public boolean isSelected() {
		return selected == true;
	}

	/**
	 * ֽ
	 * @param g Graphics
	 */
	public void paintCard(Graphics g) {
		if(!selected && face) {//ֽûѡж泯
			g.drawImage(ImageFactory.createImage(suit + "_" + point), x, y, CARD_WIDTH, CARD_HEIGHT, null);
		} else if(!selected && !face) {//ֽûѡжұ泯
			g.drawImage(ImageFactory.createImage("back"), x, y, CARD_WIDTH, CARD_HEIGHT, null);
		} else if(selected && face) {//ֽƱѡ泯
			g.setColor(Color.YELLOW);
			g.drawRect(x - 1, y - 1, CARD_WIDTH + 2, CARD_HEIGHT + 2);
			g.drawImage(ImageFactory.createImage(suit + "_" + point), x, y, CARD_WIDTH, CARD_HEIGHT, null);
		}
	}
}
