package com.mypro.threads;

import com.mypro.constant.Constant;
import com.mypro.manager.HeadFish;
import com.mypro.manager.PathManager;
import com.mypro.model.GamingInfo;
import com.mypro.model.fish.Fish;
import com.mypro.tools.LogTools;

public class FishRunThread extends Thread {
	private boolean isRun; 												// Ƿζ
	private HeadFish fish; 												// ǰ߳ҪƵͷ
	private boolean fishIsOut;											// ǷĻ							
	private int fish_speed = 1000/Constant.ON_DRAW_SLEEP;				// ٶ,Ļˢٶһ
	private float fishrunSpeed;										// ת
	public FishRunThread(HeadFish fish) {
		super();
		this.fish = fish;
		fishrunSpeed = (fish.getFish().getFishInfo().getFishRunSpeed() / Constant.ON_DRAW_SLEEP);//ֻǸٶһתٶȿȽ
	}

	public void run() {
		int[][] path = PathManager.getDefaultPath(fish);
		while (GamingInfo.getGamingInfo().isGaming()) {
			while(isRun &&!GamingInfo.getGamingInfo().isPause()){
				for (int[] pathMode : path) {
					if(fishIsOut||!isRun){
						break;
					}
					// ·Ϊתģʽ
					if (pathMode[0] == PathManager.PATH_MODE_ROTATE) {
						/**
						 * һǷͷλвͬת·
						 */
						// 㴦ڵ12
						if (fish.getFish_X() <= GamingInfo.getGamingInfo().getScreenWidth() / 2
								&& fish.getFish_Y() <= GamingInfo.getGamingInfo().getScreenHeight() / 2
								|| fish.getFish_X() > GamingInfo.getGamingInfo().getScreenWidth() / 2
								&& fish.getFish_Y() <= GamingInfo.getGamingInfo().getScreenHeight() / 2) {
							// ͷǳxĸ귽
							if (fish.getCurrentRotate() >= 90
									&& fish.getCurrentRotate() <= 270
									|| fish.getCurrentRotate() <= -90
									&& fish.getCurrentRotate() >= -270) {
								rotateLeftFish(pathMode[1]);
							} else {
								rotateRightFish(pathMode[1]);
							}
							// 㴦ڵ34
						} else {
							// ͷǳxĸ귽
							if (fish.getCurrentRotate() >= 90
									&& fish.getCurrentRotate() <= 270
									|| fish.getCurrentRotate() <= -90
									&& fish.getCurrentRotate() >= -270) {
								rotateRightFish(pathMode[1]);
							} else {
								rotateLeftFish(pathMode[1]);
							}
						}
						// ·Ϊֱģʽ
					} else {
						goStraight(pathMode[1]);
					}
				}
				if(!fishIsOut){
				// е·»ȡ·
				path = PathManager.getDefaultPath(fish);
				}else{
					while(isRun && GamingInfo.getGamingInfo().isGaming()){
						//Ļһֱ
						goStraight(100);
					}
					
				}
			}
			break;
		}
	}
	/**
	 * ƶȺ
	 */
	private void moveShoal(){
		try{
			if(fish.getShoal()==null){
				return;
			}
			for(Fish fishFlag:fish.getShoal()){
				if(!fishFlag.isCanRun()||!fishFlag.isAlive()){
					continue;
				}
				fishFlag.getFishOutlinePoint()[0] = (int)(fish.getFishOutlinePoint()[0]-fishFlag.getDistanceHeadFishX());
				fishFlag.getFishOutlinePoint()[1] = (int)(fish.getFishOutlinePoint()[1]-fishFlag.getDistanceHeadFishX());
				fishFlag.getFishOutlinePoint()[2] = (int)(fish.getFishOutlinePoint()[2]-fishFlag.getDistanceHeadFishY());
				fishFlag.getFishOutlinePoint()[3] = (int)(fish.getFishOutlinePoint()[3]-fishFlag.getDistanceHeadFishY());
				
				fishFlag.getPicMatrix().setTranslate(fish.getFish_X()-fishFlag.getDistanceHeadFishX(), fish.getFish_Y()-fishFlag.getDistanceHeadFishY());
				fishFlag.getPicMatrix().preRotate(-fish.getCurrentRotate(),fishFlag.getFishRotatePoint_X(),fishFlag.getFishRotatePoint_Y());
			}
		}catch(Exception e){
			
		}
	}
	/**
	 * ݸֱ
	 * 
	 * @param len
	 * @return true:Ļ
	 */
	private void goStraight(int len) {
		// ³㣬ֱߣתǶ
		if (fish.isNew()) {
			fish.setNew(false);
			while (GamingInfo.getGamingInfo().isGaming()) {
				while(isRun &&!GamingInfo.getGamingInfo().isPause()){
					setFishOutlintPoint(0);
					if (fish.getCurrentFromPoint() <= 1) {
						fish.setFish_X(fish.getFish_X() + fishrunSpeed);
					} else {
						fish.setFish_X(fish.getFish_X() - fishrunSpeed);
					}
					moveShoal();
					// Ƿ߳Ļ
					if (isAtOut()&&!fishIsOut) {
						setFishAtOut();
						break;
					}
					// ߹˳ȣֹͣѭ
					if ((len-=fishrunSpeed) <= 0) {
						break;
					}
					try {
						Thread.sleep(fish_speed);
					} catch (Exception e) {
	
					}
				}
				break;
			}
		} else {
			fishRun(0,len);
		}
	}

	/**
	 * תangleǶȣƶ
	 * 
	 * @param angle
	 */
	private void rotateLeftFish(int angle) {
		fishRun(1,angle);
	}

	/**
	 * תangleǶȣƶ
	 * 
	 * @param angle
	 */
	private void rotateRightFish(int angle) {
		fishRun(-1,angle);
	}
	/**
	 * ж
	 * @param mode	1:ת  -1ת   0:ֱ
	 * @param len   ƶ
	 */
	private void fishRun(int mode,int len){
		int sumLen = 0;
		while (GamingInfo.getGamingInfo().isGaming()) {
			while(isRun &&!GamingInfo.getGamingInfo().isPause()){
				// Ӿ
				setFishOutlintPoint(fish.getCurrentRotate());
				// õǰתǶ
				fish.setCurrentRotate(fish.getCurrentRotate() + mode);
				// 任
				fish.setFish_X(fish.getFish_X()
						+ (float) (fishrunSpeed*Math.cos(Math.toRadians(fish.getCurrentRotate()))));
				fish.setFish_Y(fish.getFish_Y()
						+ (float) (fishrunSpeed*Math.sin((Math.toRadians(fish.getCurrentRotate())))*-1));
				moveShoal();
				// Ƿ߳Ļ
				if (isAtOut()&&!fishIsOut) {
					setFishAtOut();
					break;
				}
				// ƶܳȣֹͣѭ
				if (++sumLen == len) {
					break;
				}
				try {
					Thread.sleep(fish_speed);
				} catch (Exception e) {
	
				}
			}
			break;
		}
	}
	

	/**
	 * ӾX,YֵСֵ
	 * 
	 * @param rotateAngle
	 *            ǸתĽǶõӦX,Yֵ
	 */
	private void setFishOutlintPoint(int rotateAngle) {
		fish.clearFishOutlinePoint();// һεķΧֵ
		int flagX = 0, flagY = 0;
		// Ͻ
		fish.getFishOutlinePoint()[0] = (int) getRotateX(0, 0,
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle)
				+ (int) fish.getFish_X();
		fish.getFishOutlinePoint()[1] = fish.getFishOutlinePoint()[0];
		fish.getFishOutlinePoint()[2] = (int) getRotateY(0, 0,
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle)
				+ (int) fish.getFish_Y();
		fish.getFishOutlinePoint()[3] = fish.getFishOutlinePoint()[2];
		// ½
		flagX = (int) getRotateX(0, fish.getFish().getPicHeight(),
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		flagY = (int) getRotateY(0, fish.getFish().getPicHeight(),
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		putFishOutline((int) (flagX + fish.getFish_X()),
				(int) (flagY + fish.getFish_Y()));
		// Ͻ
		flagX = (int) getRotateX(fish.getFish().getPicWidth(), 0, fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		flagY = (int) getRotateY(fish.getFish().getPicWidth(), 0, fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		putFishOutline((int) (flagX + fish.getFish_X()),
				(int) (flagY + fish.getFish_Y()));
		// ½
		flagX = (int) getRotateX(fish.getFish().getPicWidth(), fish.getFish().getPicHeight(),
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		flagY = (int) getRotateY(fish.getFish().getPicWidth(), fish.getFish().getPicHeight(),
				fish.getFish().getFishRotatePoint_X(), fish.getFish().getFishRotatePoint_Y(), rotateAngle);
		putFishOutline((int) (flagX + fish.getFish_X()),
				(int) (flagY + fish.getFish_Y()));
	}

	// ֻĸΧڵֵСֵȥ
	private void putFishOutline(int x, int y) {
		if (fish.getFishOutlinePoint()[1] < x) {
			fish.getFishOutlinePoint()[1] = x;
		} else if (fish.getFishOutlinePoint()[0] > x) {
			fish.getFishOutlinePoint()[0] = x;
		}
		if (fish.getFishOutlinePoint()[3] < y) {
			fish.getFishOutlinePoint()[3] = y;
		} else if (fish.getFishOutlinePoint()[2] > y) {
			fish.getFishOutlinePoint()[2] = y;
		}
	}

	/**
	 * ظתǶԼתҪתתǰX
	 * 
	 * @param x
	 * @param y
	 * @param rotatePoint_x
	 * @param rotatePoint_y
	 * @param angle
	 * @return
	 */
	private float getRotateX(float x, float y, float rotatePoint_x,
			float rotatePoint_y, float angle) {
		return (float) ((x - rotatePoint_x) * Math.cos(angle)
				+ (y - rotatePoint_y) * Math.sin(angle) + rotatePoint_x);
	}

	/**
	 * ظתǶԼתҪתתǰY
	 * 
	 * @param x
	 * @param y
	 * @param rotatePoint_x
	 * @param rotatePoint_y
	 * @param angle
	 * @return
	 */
	private float getRotateY(float x, float y, float rotatePoint_x,
			float rotatePoint_y, float angle) {
		return (float) ((y - rotatePoint_y) * Math.cos(angle)
				- (x - rotatePoint_x) * Math.sin(angle) + rotatePoint_y);
	}

	/**
	 * ǷѾĻ
	 * 
	 * @return true:Ļ
	 */
	private boolean isAtOut() {
		// ӾεϱԵĻ߶Ȼ±ԵС0϶㴦Ļ»ϱԵ
		if (fish.getFishOutlinePoint()[2] > GamingInfo.getGamingInfo().getScreenHeight()
				|| fish.getFishOutlinePoint()[3] < 0) {
			return true;

			// ͷǳxĸ귽
		} else if (fish.getCurrentRotate() >= 90
				&& fish.getCurrentRotate() <= 270
				|| fish.getCurrentRotate() <= -90
				&& fish.getCurrentRotate() >= -270) {
			// 㴦Ļ
			if (fish.getFishOutlinePoint()[1] < 0) {
				return true;
			}
		} else {
			// 㴦Ļұ
			if (fish.getFishOutlinePoint()[0] > GamingInfo.getGamingInfo().getScreenWidth()) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ˱߽Ĳ
	 */
	private void setFishAtOut() {
			fishIsOut = true;
			new Thread(new Runnable(){
				public void run() {
					try{
						// TODO Auto-generated method stub
						//ͷȺ
						for(Fish fishFlag:fish.getShoal()){
							while(GamingInfo.getGamingInfo().isGaming()){
								if(checkFishAtOut(fish,fishFlag)){
									GamingInfo.getGamingInfo().getFish().remove(fishFlag);
									GamingInfo.getGamingInfo().getSurface().removeDrawablePic(fishFlag.getFishInfo().getFishInLayer(), fishFlag);
									fishFlag.getPicActThread().stopPlay();//ֹͣ
									break;
								}
								try{
									Thread.sleep(10);
								}catch(Exception e){
									e.printStackTrace();
								}
							}
						}	
						//Ⱥƶ߳ͣ
						setRun(false);		
						//֪ͨȺѾ뿪Ļ
						if(GamingInfo.getGamingInfo().isGaming()){
							GamingInfo.getGamingInfo().getShoalManager().notifyFishIsOutOfScreen();
						}						
					}catch(Exception e){
						LogTools.doLogForException(e);
					}
				}
				
			}).start();			
	}
	/**
	 * 鵱ǰǷѾĻ
	 * @param fish
	 * @return		true:ѾĻ
	 */
	private boolean checkFishAtOut(HeadFish headFish,Fish fish){
		if(headFish.getFish_X()-fish.getDistanceHeadFishX()+fish.getPicWidth()<0||headFish.getFish_X()-fish.getDistanceHeadFishX()>GamingInfo.getGamingInfo().getScreenWidth()
				||headFish.getFish_Y()-fish.getDistanceHeadFishY()+fish.getPicHeight()<0||headFish.getFish_Y()-fish.getDistanceHeadFishY()>GamingInfo.getGamingInfo().getScreenHeight()){
			return true;
		}
		return false;
	}
	public boolean isRun() {
		return isRun;
	}

	public void setRun(boolean isRun) {
		this.isRun = isRun;
//		//õfalse,ʾֹͣ߳
//		if(!isRun){
//			//öֹ߳ͣ
//			this.fish.getPicActThread().stopPlay();
//		}
	}
}
